/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TCoreUnitRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUnit extends TableImpl<TCoreUnitRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_unit</code>
     */
    public static final TCoreUnit T_CORE_UNIT = new TCoreUnit();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreUnitRecord> getRecordType() {
        return TCoreUnitRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_unit.lastchange</code>.
     */
    public final TableField<TCoreUnitRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("CURRENT_TIMESTAMP"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_unit.pk</code>.
     */
    public final TableField<TCoreUnitRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_unit.fk_trans_key</code>.
     */
    public final TableField<TCoreUnitRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_unit.unit</code>.
     */
    public final TableField<TCoreUnitRecord, String> UNIT = createField(DSL.name("unit"), SQLDataType.CLOB.nullable(false).defaultValue(DSL.field(DSL.raw("''::text"), SQLDataType.CLOB)), this, "");

    /**
     * The column <code>common_dd.t_core_unit.is_format</code>.
     */
    public final TableField<TCoreUnitRecord, Boolean> IS_FORMAT = createField(DSL.name("is_format"), SQLDataType.BOOLEAN.defaultValue(DSL.field(DSL.raw("false"), SQLDataType.BOOLEAN)), this, "");

    private TCoreUnit(Name alias, Table<TCoreUnitRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreUnit(Name alias, Table<TCoreUnitRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_unit</code> table reference
     */
    public TCoreUnit(String alias) {
        this(DSL.name(alias), T_CORE_UNIT);
    }

    /**
     * Create an aliased <code>common_dd.t_core_unit</code> table reference
     */
    public TCoreUnit(Name alias) {
        this(alias, T_CORE_UNIT);
    }

    /**
     * Create a <code>common_dd.t_core_unit</code> table reference
     */
    public TCoreUnit() {
        this(DSL.name("t_core_unit"), null);
    }

    public <O extends Record> TCoreUnit(Table<O> path, ForeignKey<O, TCoreUnitRecord> childPath, InverseForeignKey<O, TCoreUnitRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_UNIT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreUnitPath extends TCoreUnit implements Path<TCoreUnitRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreUnitPath(Table<O> path, ForeignKey<O, TCoreUnitRecord> childPath, InverseForeignKey<O, TCoreUnitRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreUnitPath(Name alias, Table<TCoreUnitRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreUnitPath as(String alias) {
            return new TCoreUnitPath(DSL.name(alias), this);
        }

        @Override
        public TCoreUnitPath as(Name alias) {
            return new TCoreUnitPath(alias, this);
        }

        @Override
        public TCoreUnitPath as(Table<?> alias) {
            return new TCoreUnitPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreUnitRecord, Integer> getIdentity() {
        return (Identity<TCoreUnitRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreUnitRecord> getPrimaryKey() {
        return Keys.T_CORE_UNIT_PKEY;
    }

    @Override
    public List<ForeignKey<TCoreUnitRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_UNIT__FK_TRANSLATION_KEY);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_UNIT__FK_TRANSLATION_KEY, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variable</code> table
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, null, Keys.T_CORE_VARIABLE__FK_UNIT.getInverseKey());

        return _tCoreVariable;
    }

    @Override
    public TCoreUnit as(String alias) {
        return new TCoreUnit(DSL.name(alias), this);
    }

    @Override
    public TCoreUnit as(Name alias) {
        return new TCoreUnit(alias, this);
    }

    @Override
    public TCoreUnit as(Table<?> alias) {
        return new TCoreUnit(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUnit rename(String name) {
        return new TCoreUnit(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUnit rename(Name name) {
        return new TCoreUnit(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUnit rename(Table<?> name) {
        return new TCoreUnit(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit where(Condition condition) {
        return new TCoreUnit(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUnit where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUnit where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUnit where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUnit where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUnit whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
